SystemOrganization addCategory: #'TADP TP1'!

Trait named: #ConstructorConNombre
	uses: {}
	category: 'TADP TP1'!

!ConstructorConNombre classSide methodsFor: 'as yet unclassified' stamp: 'MartinPrete 5/2/2012 16:04'!
nombre: aName
	^(self new) nombre: aName.! !

Trait named: #Reservable
	uses: {}
	category: 'TADP TP1'!

!Reservable methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:57'!
costoDeTrasnporteAlEdificio: unEdificio 
	edificioEnElQueTrabaja = unEdificio ifTrue: [^0] ifFalse: [^10] .! !

!Reservable methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:56'!
costoPorAsistirALaReunionQueSeRealizaEn: unEdificio YQueDura: duracionEnHoras 
	^ (self costoDeTrasnporteAlEdificio: unEdificio) + (valorPorHoraDeTrabajo * duracionEnHoras).! !

Trait named: #TraitManejadorDeColecciones
	uses: {}
	category: 'TADP TP1'!

Trait named: #ConAgenda
	uses: TraitManejadorDeColecciones
	category: 'TADP TP1'!

ConAgenda classTrait
	uses: TraitManejadorDeColecciones classTrait!

!ConAgenda methodsFor: 'printing' stamp: 'GustavoGarayalde 5/5/2012 19:31'!
agendarEvento: unEvento
	(self agenda) agregarEvento: unEvento.! !

!ConAgenda methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:35'!
estasLibreEnEsteEvento: anEvento

	^(self agenda tieneTiempoLibreParaElEvento: anEvento)! !

!ConAgenda methodsFor: 'printing' stamp: 'ArielCapozzoli 4/21/2012 00:49'!
recorrerAgendaEnDia: unaFecha
	^ (self agenda) eventosEnLaFecha: unaFecha.
		! !

!TraitManejadorDeColecciones methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 20:03'!
buscarMayorEn: unaColeccion usandoComoValorInicial:unValorInicial  comprador: unBloqueComparador
^unaColeccion inject: unValorInicial into: [:a :c | ((unBloqueComparador value: a) > (unBloqueComparador value: c))                 ifTrue: [a]
   ifFalse: [c]].! !

!TraitManejadorDeColecciones methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 20:04'!
buscarMenorEn: unaColeccion usandoComoValorInicial:unValorInicial  comprador: unBloqueComparador
^unaColeccion inject: unValorInicial into: [:a :c | ((unBloqueComparador value: a) < (unBloqueComparador value: c))                 ifTrue: [a]
   ifFalse: [c]].! !

!TraitManejadorDeColecciones methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/27/2012 16:04'!
removerDuplicadosDe: unaColeccion condicionIgualdad: unBloqueCondicional
	^unaColeccion copy do:[:a | unaColeccion copy do:[:b | (unBloqueCondicional value:a value:b) ifTrue: [unaColeccion remove: a]]]! !

Trait named: #TraitRol
	uses: {}
	category: 'TADP TP1'!

!TraitRol methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 18:07'!
= otraClaseRol
	^(self isKindOf: otraClaseRol) ! !

!TraitRol methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 17:54'!
requerisCatering
	^((self isKindOf: Gerente) | (self isKindOf: ProjectLeader))! !

Object subclass: #Agenda
	uses: TraitManejadorDeColecciones
	instanceVariableNames: 'eventos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Agenda class
	uses: TraitManejadorDeColecciones classTrait
	instanceVariableNames: ''!

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:38'!
agregarEvento:unEvento
	eventos add: unEvento.
	"eventos sort."! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 23:26'!
eventos
	^(eventos sort)! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 02:05'!
eventosEnLaFecha:unaFecha
	^eventos select:[:unEvento | unEvento fecha = unaFecha ]! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 16:22'!
filtrarEventos:coleccionEventos enLaFecha:unaFecha
	^coleccionEventos select:[:unEvento | unEvento fecha = unaFecha ]! !

!Agenda methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/6/2012 15:22'!
initialize 
	eventos:= OrderedCollection new.! !

!Agenda methodsFor: 'accessing' stamp: 'MartinPrete 4/27/2012 16:03'!
tiemposLibresQueDurenComoMinimo:unaDuracion desde:horaEntrada hasta:horaSalida
	|tiemposLibres condicion|	
	tiemposLibres := OrderedCollection new.
	
	"Pedimos a cada evento que nos diga que horas del dia deja libres."
	eventos do:[:e | tiemposLibres addAll: (e horasQueDejaLibre)].

	"Removemos eventos que esten fuera del rango y acotamos para que queden dentro de Entrada/Salida de la Persona."
	tiemposLibres := (tiemposLibres select:[:e |  (((e horaFin) > horaEntrada)  & ((e horaInicio) < horaSalida))])
		 collect:[:e | e ajustarInicio: horaEntrada fin: horaSalida].	

	"Terminamos de limpiar los tiempos que pisen a otros eventos dentro del dia."
	tiemposLibres copy do:[ :tl | 
		eventos do:[:e | (e estaContenidoDentroDe: tl) ifTrue:[tl horaFin:e horaInicio] ifFalse:[(tl seSuperPoneCon: e) ifTrue: [tl acotarSegun:e]]]].

	"Filtramos las franjas de tiempo libre que duren lo requerido y removemos duplicados."
	tiemposLibres := ((tiemposLibres select:[:e | (e duraMasQue: unaDuracion)]) asSet) asOrderedCollection. 
	condicion:=[:x :y | ((x~=y)&((x horaInicio) = (y horaInicio))&((x horaFin) = (y horaFin)))].
	self removerDuplicadosDe: tiemposLibres condicionIgualdad: condicion.
	
	"Finalmenter ordenamos las franjas horarias por hora de inicio."
	tiemposLibres sort.
		
	^tiemposLibres! !

!Agenda methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 19:20'!
tieneTiempoLibreParaElEvento:unEvento
	(eventos size > 0) ifTrue: [^unEvento seSuperPoneConAlgunOtroEvento: (self eventos)] ifFalse: [^true] ! !

Object subclass: #Edificio
	uses: ConstructorConNombre
	instanceVariableNames: 'nombre salas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Edificio class
	uses: ConstructorConNombre classTrait
	instanceVariableNames: ''!

!Edificio methodsFor: 'accessing' stamp: 'NahuelBarroso 4/21/2012 00:05'!
agregarSala: aSala
	self salas add: aSala.! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:48'!
buscaUnaSalaXEvento: anEvento

	^self salas detect:[:each | each estasLibreEnEsteEvento: anEvento].! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 4/21/2012 00:01'!
initialize
	salas := OrderedCollection new.
	! !

!Edificio methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:02'!
nombre: anObject
	nombre := anObject! !

!Edificio methodsFor: 'accessing' stamp: 'NahuelBarroso 4/20/2012 23:47'!
salas
	^ salas! !

!Edificio methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:46'!
tenesAlgunaSalaLibreEnElIntervalo: anEvento 
	^salas anySatisfy: [ :unaSala | unaSala estasLibreEnEsteEvento: anEvento].! !

Object subclass: #Empresa
	instanceVariableNames: 'edificios herramientas personas proyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Empresa methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:45'!
agregarEdificio: anEdificio 
	edificios add: anEdificio.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:46'!
agregarPersona: aPersona 
	self personas add: aPersona.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'Gustavo 4/16/2012 00:39'!
agregarProyecto: unProyecto 
	(self proyectos) add: unProyecto.! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ArielCapozzoli 4/25/2012 19:05'!
buscaSalaXEvento: anEvento
|sala|
	self edificios do: [:edificio| sala = edificio buscaUnaSalaXEvento: anEvento. sala ifNotNilDo: [^sala] ].
	^nil
! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:17'!
buscarPersonasRequeridas: coleccionFiltros
	^coleccionFiltros collect: [:unFiltro | unFiltro buscarPersonaQueTeCumple: personas]! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:33'!
buscarSalaLibreEnElIntervalo: anEvento
	| salas |
	salas := OrderedCollection new.
	edificios do: [:unEdificio | salas addAll: (unEdificio salas)].
	^salas detect: [:unaSala | unaSala estasLibreEnEsteEvento: anEvento].! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
edificios
	^ edificios! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
edificios: anObject
	edificios := anObject! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:37'!
hayAlgunaSalaLibreEnElIntervalo: unIntervalo 
	^edificios anySatisfy: [ :unEdificio | unEdificio tenesAlgunaSalaLibreEnElIntervalo: unIntervalo].! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'ArielCapozzoli 5/5/2012 01:19'!
haySalaXParaEvento: anEvento
|sala|
	self edificios do: [:edificio| sala = edificio buscaUnaSalaXEvento: anEvento. sala ifNotNilDo: [^true] ].
	^false! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
herramientas
	^ herramientas! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
herramientas: anObject
	herramientas := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'Gustavo 4/16/2012 00:38'!
initialize 
	personas:= OrderedCollection new.
	herramientas:= OrderedCollection new.
	proyectos:= OrderedCollection new.
	edificios:= OrderedCollection new.! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
personas
	^ personas! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
personas: anObject
	personas := anObject! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
proyectos
	^ proyectos! !

!Empresa methodsFor: 'accessing' stamp: 'GustavoGarayalde 4/13/2012 21:13'!
proyectos: anObject
	proyectos := anObject! !

Object subclass: #Evento
	instanceVariableNames: 'horaInicio horaFin fecha'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Evento class methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/23/2012 15:41'!
horaInicio: hi horaFin: hf
	^(self new) horaInicio:hi; horaFin: hf; fecha:Date today;yourself.! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 23:33'!
<=otroEvento
	(self fecha = otroEvento fecha) ifTrue:[^(self horaInicio <= otroEvento horaInicio)] ifFalse: [^(self fecha <= otroEvento fecha)].
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:26'!
acotarSegun:otroEvento
	|condicion contenidoDentro|
	condicion:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].

	"cota superior superpuesta"
	(condicion value: (self horaInicio)) ifTrue: [ self horaInicio: (otroEvento horaFin)].

	"cota inferior superpuesta"
	(condicion value: (self horaFin)) ifTrue: [ self horaFin: (otroEvento horaInicio)].

	
! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 18:31'!
ajustarInicio: horaEntrada fin:horaSalida
	 (self horaInicio < horaEntrada) ifTrue: [self horaInicio: horaEntrada].
	 (self horaFin > horaSalida) ifTrue: [self horaFin: horaSalida].
! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/27/2012 15:31'!
comparteHoraInicioFinCon:otroEvento
	^((self horaInicio  = otroEvento horaInicio) & (self horaFin  = otroEvento horaFin))
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 16:27'!
duraMasQue: unaDuracion
	^((self horaInicio addTime: unaDuracion) <= (self horaFin))! !

!Evento methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:17'!
duracion: duracionEnHoras 
	horaFin := Time hour: ((horaInicio hour) + duracionEnHoras) minute: (horaInicio minute) second: (horaInicio second).! !

!Evento methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/25/2012 19:31'!
esPosibleEmpezando: unaHoraInicio conDuracion: duracion  
	(self horaInicio > self horaFin)
	ifTrue: [^false].
	(((self horaInicio) addTime: duracion) > self horaFin)
	ifTrue: [^false].
	((unaHoraInicio addTime: duracion) > self horaFin)
	ifTrue: [^false]. 
	(self horaInicio > unaHoraInicio)
	ifFalse: [self horaInicio: unaHoraInicio].
	^true! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:27'!
estaContenidoDentroDe:otroEvento
	|contenidoDentro|
	contenidoDentro:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].
		
	"uno contenido dentro de otro"
	^((contenidoDentro value: (self horaInicio)) & (contenidoDentro value: (self horaFin)))! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 00:43'!
fecha
	^ fecha! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 01:12'!
fecha: anObject
	fecha := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 15:51'!
fecha: fechaEvento horaInicio:horaInicioEvento horaFin:horaFinEvento
	self fecha: (Date readFrom: fechaEvento readStream).
	self horaInicio: (Time readFrom: horaInicioEvento readStream).
	self horaFin: (Time readFrom: horaFinEvento readStream).! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaFin
	^ horaFin! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaFin: anObject
	horaFin := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:18'!
horaInicio
	^ horaInicio! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 01:12'!
horaInicio: anObject
	horaInicio := anObject! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 16:22'!
horasQueDejaLibre
	|tiemposLibres diaCompleto| 
	tiemposLibres:= OrderedCollection new.
	diaCompleto :=Evento new.
	(diaCompleto horaInicio < self horaInicio) ifTrue: [tiemposLibres add: (Evento horaInicio: (diaCompleto horaInicio) horaFin: (self horaInicio))].
	(diaCompleto horaFin > self horaFin) ifTrue: [tiemposLibres add: (Evento horaInicio: (self horaFin) horaFin: (diaCompleto horaFin))].
	
	^tiemposLibres! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:56'!
initialize 
	horaInicio :=Time readFromString: '00:00'.
	horaFin := Time readFromString: '23:59'.
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/27/2012 00:02'!
seSuperPoneCon:otroEvento
	|condicion contenidoDentro|
	"Bloques de condiciones para repetir menos"
	condicion:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].
	contenidoDentro:=[:h | ((h>=(otroEvento horaInicio)) & (h<=(otroEvento horaFin)))].
		
	"Si es el mismo evento, entonces no se superponen."
	(self == otroEvento) ifTrue: [^false]
	
	"Si son diferentes, evaluamos los bloques."
	ifFalse:[^(	(condicion value: (self horaInicio)) | 		"cota superior superpuesta"
				(condicion value: (self horaFin)) | 		"cota inferior superpuesta"
				((contenidoDentro value: (self horaInicio)) & (contenidoDentro value: (self horaFin))))] "uno contenido dentro de otro"
	! !

!Evento methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 15:29'!
seSuperPoneConAlgunOtroEvento:unaColeccionDeEventos
	^ unaColeccionDeEventos anySatisfy: [:unEvento | unEvento seSuperPoneCon: self].
! !

!Evento methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:04'!
sumarMinutosALaHoraDeInicio: minutos 
	horaInicio := Time hour: (horaInicio hour) minute: ((horaInicio minute) + minutos) second: (horaInicio second).! !

Object subclass: #Filtro
	instanceVariableNames: 'condiciones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:08'!
agregarCondicion: unaCondicion
	condiciones add: unaCondicion ! !

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:11'!
aplicarA: unaPersona
	^condiciones allSatisfy:[:c| c value:unaPersona ]! !

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/22/2012 17:48'!
buscarPersonaQueTeCumple: coleccionPersonas
	^coleccionPersonas detect: [:unaPersona | self aplicarA: unaPersona ] 
		ifNone:[^self error: 'Ninguna persona cumple con las condiciones del filtro.']! !

!Filtro methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/21/2012 02:14'!
initialize 
	condiciones := OrderedCollection new.! !

Object subclass: #Herramienta
	uses: ConAgenda + Reservable
	instanceVariableNames: 'agenda valorPorHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Herramienta class
	uses: ConAgenda classTrait + Reservable classTrait
	instanceVariableNames: ''!

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:13'!
agenda
	^ agenda! !

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:13'!
agenda: anObject
	agenda := anObject! !

!Herramienta methodsFor: 'printing' stamp: 'GustavoGarayalde 5/5/2012 19:30'!
agendarEvento: unaReunion
	|evento|.
	evento := Evento new.
	evento horaInicio: unaReunion horaInicio.	
	evento horaFin: unaReunion horaFin.
	(self agenda) agregarEvento: evento.! !

!Herramienta methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:58'!
costoPorAsistirALaReunionQueSeRealizaEn: unEdificio YQueDura: duracionEnHoras 
	^ (self costoDeTrasnporteAlEdificio: unEdificio) + (valorPorHora * duracionEnHoras).! !

!Herramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:22'!
initialize
	agenda := Agenda new.
	! !

!Herramienta methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:02'!
valorPorHora
	^ valorPorHora! !

!Herramienta methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:02'!
valorPorHora: anObject
	valorPorHora := anObject! !

Herramienta subclass: #RecursoLimitado
	instanceVariableNames: 'nombre cantidadTotal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
cantidad
	^ cantidadTotal! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 00:57'!
cantidad: anObject
	cantidadTotal := anObject! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 5/5/2012 01:36'!
hay:unNumero paraEvento: unEvento

 | eventosEnFecha cantidadReservada |
 
 "busco los eventos de ese dia"
 
 eventosEnFecha := (self agenda) recorrerAgendaEnDia: (unEvento fecha).
 
 "busco la cantidad de reservas, recordando q un evento en agenda es reserva de una unidad"
 
 cantidadReservada:= [(self Agenda) select: [:evento | evento seSuperPoneCon: unEvento]] size.

 unNumero<((self cantidad) - cantidadReservada)
 ifTrue:[
  ^true].
 ^false! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:25'!
nombre
	^ nombre! !

!RecursoLimitado methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/16/2012 23:25'!
nombre: anObject
	nombre := anObject! !

Herramienta subclass: #Sala
	instanceVariableNames: 'nombre edificioEnElQueSeEncuentra'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Sala class methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 20:02'!
constructorConEdificio: unEdificio costo: unCosto

	^(self new) edificioEnElQueSeEncuentra: unEdificio; valorPorHora: unCosto;yourself.! !

!Sala methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:13'!
edificio: anEdificio 
	edificioEnElQueSeEncuentra := anEdificio.! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:03'!
edificioEnElQueSeEncuentra
	^ edificioEnElQueSeEncuentra! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 17:03'!
edificioEnElQueSeEncuentra: anObject
	edificioEnElQueSeEncuentra := anObject! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 14:05'!
nombre
	^ nombre! !

!Sala methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 14:05'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Persona
	uses: ConAgenda + Reservable
	instanceVariableNames: 'nombre horaEntrada horaSalida proyectoAlQueEstaAsignado sector rol edificioEnElQueTrabaja agenda valorPorHora'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Persona class
	uses: ConAgenda classTrait + Reservable classTrait
	instanceVariableNames: ''!

!Persona class methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 20:00'!
nombre: aName horaEntrada: horarioEntrada horaSalida: horarioSalida sueldo:unSueldo sector: unSector rol:unRol proyecto:unProyecto edificio:unEdificio

^(self new) nombre: aName;horaEntrada: horarioEntrada;horaSalida: horarioSalida;valorPorHora: unSueldo;sector: unSector;rol: unRol; proyectoAlQueEstaAsignado:unProyecto;edificioEnElQueTrabaja:unEdificio; yourself.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:19'!
agenda
	^ agenda! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:19'!
agenda: anObject
	agenda := anObject! !

!Persona methodsFor: 'printing' stamp: 'GustavoGarayalde 5/5/2012 19:30'!
agendarEvento: unaReunion
	|evento|.
	evento := Evento new.
	evento horaInicio: unaReunion horaInicio.	
	evento horaFin: unaReunion horaFin.
	(self agenda) agregarEvento: evento.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:59'!
costoPorAsistirALaReunionQueSeRealizaEn: unEdificio YQueDura: duracionEnHoras 
	^ (self costoDeTrasnporteAlEdificio: unEdificio) + (valorPorHora * duracionEnHoras).! !

!Persona methodsFor: 'accessing' stamp: 'NahuelBarroso 5/5/2012 17:42'!
cualEsTuHorarioComunCon: personas
	|thisReunionEvent|
	
	thisReunionEvent := Evento new.
	
	^thisReunionEvent horaInicio: (self buscarMayorEn:  personas usandoComoValorInicial:(Persona new)  comprador: [:p|p horaEntrada]) horaEntrada;
						 horaFin: (self buscarMenorEn:  personas usandoComoValorInicial:(Persona new)  comprador: [:p|p horaSalida]) horaSalida;yourself.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/26/2012 23:56'!
dameTusTiemposLibresParaUnaReunionQueDure:unaDuracion 
	^(agenda tiemposLibresQueDurenComoMinimo: unaDuracion desde: horaEntrada hasta: horaSalida)! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
edificioEnElQueTrabaja
	^ edificioEnElQueTrabaja! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
edificioEnElQueTrabaja: anObject
	edificioEnElQueTrabaja := anObject! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 22:11'!
horaEntrada
	^ horaEntrada! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:40'!
horaEntrada: anObject
	horaEntrada := (Time readFrom: anObject readStream)! !

!Persona methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 22:11'!
horaSalida
	^ horaSalida! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/23/2012 00:40'!
horaSalida: anObject
	horaSalida := (Time readFrom: anObject readStream)! !

!Persona methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 20:06'!
imputarCosto: unCosto 
	proyectoAlQueEstaAsignado imputarCosto: unCosto.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/22/2012 20:09'!
initialize 
	agenda := Agenda new.
	horaEntrada := Time readFromString: '09:00'.
	horaSalida := Time readFromString: '18:00'.! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
nombre
	^ nombre! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
nombre: anObject
	nombre := anObject! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
proyectoAlQueEstaAsignado
	^ proyectoAlQueEstaAsignado! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
proyectoAlQueEstaAsignado: anObject
	proyectoAlQueEstaAsignado := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 5/3/2012 15:57'!
requerisCatering 
	^rol requerisCatering! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
rol
	^ rol! !

!Persona methodsFor: 'accessing' stamp: 'NahuelBarroso 5/3/2012 17:10'!
rol: unaClaseRol
	rol := unaClaseRol! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
sector
	^ sector! !

!Persona methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 17:44'!
sector: anObject
	sector := anObject! !

!Persona methodsFor: 'as yet unclassified' stamp: 'MartinPrete 4/20/2012 21:08'!
trabajasEnElProyecto: nombreProyecto 
	^(proyectoAlQueEstaAsignado nombre) = nombreProyecto.! !

!Persona methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 5/3/2012 17:00'!
tuRolEs: nombreRol
	^(rol nombre) = nombreRol! !

!Persona methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 19:59'!
valorPorHora
	^ valorPorHora! !

!Persona methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:00'!
valorPorHora: anObject
	valorPorHora := anObject! !

Object subclass: #Proyecto
	uses: ConstructorConNombre
	instanceVariableNames: 'nombre costo personas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Proyecto class
	uses: ConstructorConNombre classTrait
	instanceVariableNames: ''!

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 18:45'!
agregarPersona: unaPersona
	unaPersona proyectoAlQueEstaAsignado: self.
	personas add: unaPersona.! !

!Proyecto methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:07'!
costo
	^ costo! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 20:07'!
imputarCosto: unCosto
	costo := (costo+unCosto).! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/5/2012 18:27'!
initialize 
	costo := 0.
	personas := OrderedCollection new.! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:04'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 20:04'!
nombre: anObject
	nombre := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:02'!
valorPorHora
	^ costo! !

Object subclass: #ReservaHerramienta
	instanceVariableNames: 'herramienta cantidad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
cantidad
	^ cantidad! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
cantidad: anObject
	cantidad := anObject! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
herramienta
	^ herramienta! !

!ReservaHerramienta methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/19/2012 23:47'!
herramienta: anObject
	herramienta := anObject! !

Object subclass: #Reunion
	uses: TraitManejadorDeColecciones
	instanceVariableNames: 'personaQueLaConvoca sala herramientas requiereCatering personas horaInicio horaFin fecha duracion empresa integrantes horario costo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

Reunion class
	uses: TraitManejadorDeColecciones classTrait
	instanceVariableNames: ''!

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 19:29'!
agendarEnTodos
	integrantes do: [ :unIntegrante | unIntegrante agendarEvento: horario].
	  
	! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 00:57'!
agregarHerramienta: unaHerramienta
	| reservaAux |
	reservaAux := ReservaHerramienta new.
	reservaAux herramienta: unaHerramienta.
	reservaAux cantidad: 1.
	herramientas add reservaAux.
	! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/20/2012 00:57'!
agregarHerramienta: unaHerramienta cuantas: unNumero
	| reservaAux |
	reservaAux := ReservaHerramienta new.
	reservaAux herramienta: unaHerramienta.
	reservaAux cantidad: unNumero.
	herramientas add reservaAux.
	! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:22'!
buscarHorarioParaLaReunionDentroDelIntervalo: unIntervalo
	| horarioReunion |
	[(unIntervalo horaInicio) < (unIntervalo horaFin)]
		whileTrue: [ 
			horarioReunion := (Evento new) horaInicio: (unIntervalo horaInicio); duracion: duracion.
			((self estanTodosLosIntegrantesLibresEnElIntervalo: horarioReunion) & (empresa hayAlgunaSalaLibreEnElIntervalo: horarioReunion)) ifTrue: [ ^horarioReunion ] ifFalse: [ unIntervalo sumarMinutosALaHoraDeInicio: 1 ].
		].! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:51'!
calcularCosto
	^integrantes inject: 0 into: [ :costoReunion :unIntegrante | costoReunion +  (unIntegrante costoPorAsistirALaReunionQueSeRealizaEn: (sala edificioEnElQueSeEncuentra) YQueDura: duracion)].! !

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:05'!
calcularEImputarCostos
	costo := self calcularCosto.
	personaQueLaConvoca imputarCosto: costo.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/25/2012 23:16'!
duracion
	^duracion! !

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 19:07'!
duracion: anObject
	duracion := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:22'!
empresa
	^empresa! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/21/2012 01:22'!
empresa: anObject
	empresa := anObject.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 18:19'!
estanTodosLosIntegrantesLibresEnElIntervalo: unEvento 
	^integrantes allSatisfy: [ :unIntegrante | unIntegrante estasLibreEnEsteEvento: unEvento].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:22'!
fecha
	^ fecha! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:22'!
fecha: anObject
	fecha := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 5/5/2012 01:30'!
fechaLibreEnAgendasPara: unEvento 
 	|i|	
	unEvento fecha: self fecha.
 	i := 1.
 	[((self fechaLibreHerramientasPara: unEvento) & (self fechaLibrePersonasPara: unEvento) & (self fechaLibreSalaPara: unEvento)) | 
	(i > 10)]
 	whileFalse:[ 
  		self fecha: ((self fecha) addDays:1).
 		unEvento fecha: self fecha.
		i := (i + 1).
	 ]! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 5/5/2012 01:18'!
fechaLibreHerramientasPara: unEvento 
 ^(self herramientas) allSatisfy: [:reservaAux | (reservaAux herramienta)hay: (reservaAux cantidad) paraEvento: unEvento]! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 5/5/2012 01:18'!
fechaLibrePersonasPara: unEvento 
 ^(self personas) allSatisfy: [:persona | (persona agenda)tieneTiempoLibreParaElEvento: unEvento]
! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 5/5/2012 01:21'!
fechaLibreSalaPara: unEvento 
 ^((self sala agenda) tieneTiempoLibreParaElEvento: unEvento) or: [self empresa haySalaXParaEvento: unEvento]
	
	
	
	
! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 5/5/2012 01:26'!
herramientas
	^herramientas! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:14'!
horaFin
	^horaFin.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:15'!
horaFin: unaHora
	horaFin:= unaHora.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/6/2012 15:17'!
horaInicio
	^ horaInicio! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/19/2012 01:15'!
horaInicio: unaHora
	horaInicio:= unaHora.! !

!Reunion methodsFor: 'as yet unclassified' stamp: 'GustavoGarayalde 5/5/2012 19:25'!
horario: anEvento 
	horario := anEvento.! !

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 19:39'!
horarioEnElQuePuedeRealizarse
	| intervaloComun horarioReunion |
	
	intervaloComun := ((self personaQueLaConvoca) cualEsTuHorarioComunCon: personas).
	
	horarioReunion := self buscarHorarioParaLaReunionDentroDelIntervalo: intervaloComun.
	
	sala := empresa buscarSalaLibreEnElIntervalo: intervaloComun.
	
	integrantes add: sala.
	
	self horario: horarioReunion.
	
	self agendarEnTodos.! !

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 20:02'!
imputarCostoHerramientas
	herramientas do:[ :unaHerramienta | (self proyectoQueLaRequirio) imputarCosto: unaHerramienta valorPorHora].! !

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 19:59'!
imputarCostoPersonas
	personas do:[ :unaPersona | (self proyectoQueLaRequirio) imputarCosto: ((unaPersona valorPorHora) * (duracion hours))].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:34'!
imputarCostoTransporte
	self proyectoQueLaRequirio imputarCosto: ((self personasQueRequierenTransporte) size) * 50.! !

!Reunion methodsFor: 'accessing' stamp: 'ArielCapozzoli 4/18/2012 18:36'!
initialize 
	requiereCatering :=false.
	personas := OrderedCollection new.
	herramientas:= OrderedCollection new.
	self fecha: Date today.! !

!Reunion methodsFor: 'accessing' stamp: 'GustavoGarayalde 5/5/2012 18:32'!
integrantes: anObject
	integrantes := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/25/2012 23:16'!
personaQueLaConvoca
	^personaQueLaConvoca! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 20:59'!
personaQueLaConvoca: unaPersona
	personaQueLaConvoca := unaPersona.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/14/2012 16:03'!
personas
	^ personas! !

!Reunion methodsFor: 'accessing' stamp: 'NahuelBarroso 4/24/2012 14:29'!
personas: anObject
	personas := anObject! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:32'!
personasDeOtrosProyectos
	^(self personas select: [:unaPersona | (unaPersona trabajasEnElProyecto:  ((self proyectoQueLaRequirio) nombre)) not])
	
	
! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 5/2/2012 15:34'!
personasQueRequierenTransporte
	^(self personasDeOtrosProyectos) select:[:unaPersona | unaPersona edificioEnElQueTrabaja ~= (self sala edificioEnElQueSeEncuentra)].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/20/2012 21:00'!
proyectoQueLaRequirio
	^ personaQueLaConvoca proyectoAlQueEstaAsignado.! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/22/2012 17:54'!
requiereCatering
	^ requiereCatering | personas anySatisfy:[:unaPersona | (unaPersona rol requerisCatering)].! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:51'!
sala
	^ sala! !

!Reunion methodsFor: 'accessing' stamp: 'MartinPrete 4/4/2012 19:51'!
sala: anObject
	sala := anObject! !

Object subclass: #Rol
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!Rol class methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 5/3/2012 16:53'!
nombre: aName
	^(self new) nombre: aName! !

!Rol methodsFor: 'accessing' stamp: 'NahuelBarroso 5/3/2012 16:54'!
nombre
	^ nombre! !

!Rol methodsFor: 'accessing' stamp: 'NahuelBarroso 5/3/2012 16:54'!
nombre: anObject
	nombre := anObject! !

Rol subclass: #RolConCatering
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!RolConCatering methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 5/3/2012 16:51'!
requerisCatering 
	^true! !

Rol subclass: #RolSinCatering
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP TP1'!

!RolSinCatering methodsFor: 'as yet unclassified' stamp: 'NahuelBarroso 5/3/2012 16:51'!
requerisCatering 
	^false! !
